#!/usr/bin/perl -w

## $Id: ads3kp_read2.pl 22 2013-07-18 05:58:32Z sekido $
## Updated on $Date: 2013-07-18 14:58:32 +0900 (Thu, 18 Jul 2013) $ by $Auther$
$rev = '$Rev: 22 $ updated on $Date: 2013-07-18 14:58:32 +0900 (Thu, 18 Jul 2013) $';

#use strict;
#use Net::Telnet;
use lib "$ENV{HOME}/prog/perl/module";
use lib "/usr/local/share/ADS3kp";
use ADS3kp;

sub usage(){
    print "Usage: $0 -a <ads3k hostname/ipaddress>\n";
    print " Default hostname = 133.243.128.80\n";
    print " Version: $rev\n";
    exit 1;
}


{
    # ڑ(ɍ킹ďC)
    my $usr = 'root';	# [U
    my $pass = "redhat";
#    my $pass = 'ksrc$34m';	# pX[h
    #my $prompt = '/\[.+\]\$ $/';	# vvg(K\)

#    my $prompt = '/cosmo login:$|Password:$|\[.+\]\$ $/';# vvg(K\)

    my $host = '133.243.128.80';
    my @result;
    
    usage() if (@ARGV<1);
    my $ads = new ADS3kp;
    while(@ARGV){
	my $opt = shift;
	if($opt =~/-a/){
	    $host = shift;
	    $ads->SetHost($host,$usr,$pass);
	    print "Host = $host \n" ;
	}
    }
    
    my @sigchk = $ads->SigCheck();
#    print @sigchk;
    my @cfrq = $ads->ReadLo();
    my @hfrq = $ads->HexFreq();
    my @bw = $ads->ReadBW();
    @ulsb= $ads->ULSB() if( $ads->ReadULSB() == 0);
    my @ifin = $ads->IFin()if( $ads->ReadIFin() == 0);
    my @frq = $ads->ReadBLo(1);

    for(my $i=0; $i<@frq; $i++){
#	print STDERR "ulsb[$i]= $ulsb[$i]\n";
	if($ulsb[$i] == 0){
	    printf "%2d %7.6f MHz %s %d %5.2f MHz USB\n", 
	    $i+1, $frq[$i]*1.e-6, $hfrq[$i], $ifin[$i], $bw[$i]*1.e-6;
	}elsif($ulsb[$i] == 1){
	    printf "%2d %7.6f MHz %s %d %5.2f MHz LSB\n", 
	    $i+1, $frq[$i]*1.e-6, $hfrq[$i], $ifin[$i], $bw[$i]*1.e-6;
	}elsif($ulsb[$i] == 2){
	    printf "%2d %7.6f MHz %s %d %5.2f MHz Cmplx\n", 
	    $i+1, $frq[$i]*1.e-6, $hfrq[$i], $ifin[$i], $bw[$i]*1.e-6;
	}else{
	    printf "%2d %7.6f MHz %s %d %5.2f MHz $ulsb[$i]\n", 
	    $i+1, $frq[$i]*1.e-6, $hfrq[$i], $ifin[$i], $bw[$i]*1.e-6;
	}
    }



}
